<template>
</template>

<script lang="ts">
import { Component, Watch, Vue } from 'vue-property-decorator';
import { setupVuekey } from '..';

const vuekey = setupVuekey<SpecComponent>();

@Component
export default class SpecComponent extends Vue {
  profile: {
    age?: number;
    name?: string;
  } = {};

  arr = [1,'ss',3];

  depth0?: {
    depth1?: {
      count: number;
      depth2: {
        depth3?: {
          depth4?: {
            depth5?: {
              depth6?: {
                depth7: {
                  depth8?: {

                  }
                }
              }
            }
          }
        }
      }
    }
  } = {};

  @Watch(vuekey('depth0', 'depth1', 'depth2', 'depth3', 'depth4', 'depth5'))
  onChangeCount(): void {
    this.$set(...vuekey(this.arr, 1, 'a'));
  }

  @Watch(vuekey('depth0', 'depth1', 'depth2', 'depth3', 'depth4', 'depth5', 'depth6', 'depth7', 'depth8'))
  onChangeDeep(): void {}
}
</script>

<style scoped>
</style>
